SPR16:
	push hl
	ld h, 0			
	ld c, e
	ld b, h
	ld a,c
	add a,a
	add a,a
	ld l,a
	add hl,hl
	add hl, bc
	add hl, bc
	add hl, bc
	ld a, d
	srl a
	srl a
	srl a
	add a, l
	ld l,a
	ld a, h
	adc a, $90
	ld h, a
	ld a,d
	and %00000111
	pop ix
	ld b, (ix+0)
	inc ix
	ld c, a
ds21lp:
	push bc
	ld e, (ix + 0)
	ld d, (ix + 1)
	ld a, c
	ld c, 0
	or a
	jr z, skiprotate
	ld b, a
ds21lp2:
	rr e
	rr d
	rr c
	djnz ds21lp2
skiprotate:
	ld a, (hl)
	or e
	ld (hl), a
	inc hl
	ld a, (hl)
	or d
	ld (hl), a
	inc hl
	ld a, (hl)
	or c
	ld (hl), a
	inc ix
	inc ix
	ld bc, 9
	add hl, bc
	pop bc
	djnz ds21lp
	ret

SPR8:
	push hl
	ld h, 0				;code borrowed from findpixel
	ld c, e
	ld b, h
	ld a,c
	add a,a
	add a,a
	ld l,a
	add hl,hl
	add hl, bc
	add hl, bc
	add hl, bc
	ld a, d
	srl a
	srl a
	srl a
	add a, l
	ld l,a
	ld a, h
	adc a, $90
	ld h, a
	ld a,d
	and %00000111
	pop ix
	ld b, (ix+0)
	inc ix
	ld c, a
ds8lp:
	push bc
	ld e, (ix + 0)
	ld a, c
	ld d, 0
	or a
	jr z, skiprotate8
	ld b, a
ds8lp2:
	rr e
	rr d
	djnz ds8lp2
skiprotate8:
	ld a, (hl)
	or e
	ld (hl), a
	inc hl
	ld a, (hl)
	or d
	ld (hl), a
	inc ix
	ld bc, 10
	add hl, bc
	pop bc
	djnz ds8lp
	ret

clearscreen2:
	ld a, (counter)			;get counter of 0-63
	and %11111100
	rra
	rra
	ld c, a					;multiply by 11
	ld b, 0
	add a, a
	add a, a
	ld l, a
	ld h, b
	add hl, hl
	add hl, bc
	add hl, bc
	add hl, bc
	push hl
	ld de, 704
	ex de, hl
	sbc hl, de
	push hl
	pop bc
	ld hl, $9000
	pop de
	add hl, de
	push de
	ld de, starfield
	ex de, hl
	ldir
	pop bc
	ld a, c
	or a
	ret z
	ld de, $9000
	ldir
	ret

; hl=starfield, get de=ca00+11*a for start and bc=704-11a for duration, ldir
; de=$ca00, hl already set, bc=11a for duration

clearscreen:
	ld hl, $fc00
	ld (hl), l
	ld de, $fc01
	ld bc, 1023
	ldir
	ret

copyscreen:
	ld hl, $9000
	ld de, $fc00
	ld b, 64
cslp:
	push bc
	ld bc, 11
	ldir
	inc de
	inc de
	inc de
	inc de
	inc de
	pop bc
	djnz cslp
	ret

loadsidebar:
	ld hl, Sidebar
	ld de, $fc0b
	ld b, 64
lsblp:
	push bc
	ld bc, 5
	ldir
	push hl
	ld hl, 11
	add hl, de
	ex de, hl
	pop hl
	pop bc
	djnz lsblp
	ret

getrandom:
	ld a, (xcounter)
	ld b, a
	ld a, (counter)
	ld d, a
	ld a, r
	add a, b
	add a, d
	ret

;Old Routines:
keyloop:
	ld l, 0
keyloopb:
	push bc
	ld b, 10
keyloop2:
	ld e, 128
 	ld a,%1111110
	out (1),a
 	nop
 	in a,(1)
 	rra
 	call nc,ldkey
	rrc e
 	rra
 	call nc,ldkey
	rrc e
 	rra
 	call nc,ldkey
	rrc e
 	rra
 	call nc,ldkey
	rrc e
	ld a,%00111111
	out (1), a
	nop
	in a, (1)
	and %01000000
	call z, ldkey
	rrc e
	in a, (1)
	ld h, a
	and %00100000
	call z, ldkey
	rrc e
	ld a, %01011111
	out (1), a
	nop
	in a, (1)
	push af
	and %10000000
	call z, ldkey
	rrc e
	pop af
	and %01000000
	call z, ldkey
	djnz keyloop2
	pop bc
	djnz keyloopb
	ld a, l
	ld (keyvar), a
	ret
ldkey:
	ld d, a
	ld a, l
	or e
	ld l, a
	ld a, d
	ret
; keys:
; 0=nothing
; 8=down
; 7=left
; 6=right
; 5=up
; 4=exit
; 3=2nd
; 2=alpha			;this bit-1 turned on
; 1=graph

waitkey:
	ld b, 1
	call keyloop
	or a
	jr nz, waitkey
	ret

pause:
	call waitkey
pause3:
	ld b, 1
	call keyloop
	and %00000100
	jr z, pause3
	jp waitkey

updatehealth:
	ld hl, $fe1c
	ld a, (health)
	ld b, 30
	ld c, 0
	ld de, 16
uhlp:
	cp b
	jr nz, not255
	dec c
not255
	ld (hl), c
	add hl, de
	djnz uhlp
	ret

updatevars:
	ld a, (wave)
	inc a
	ld de, $016b
	call drawbyte
	ld hl, (score)
	ld de, $076b
	call drawnumber
	ld a, (missilenum)
	ld de, $0d6b
	call drawbyte
	ld a, (bombnum)
	ld de, $136b
	jr drawbyte

drawbyte:
	ld l, a
	ld h, 0
drawnumber:
;Borrowed from Jezzball by Magnus Svedin 
  ld (_PenCol), de
  ld de, ScoreTxt+4   ;buffer to store ASCII in
  ld b, $05           ;number of digits to print
PNStl1:
  call _divHLby10      ;call function to convert from number to digit
  add a, '0'          ;convert digit to ASCII-number for digit
  ld (de), a          ;store in ASCII-buffer
  dec de
  djnz PNStl1         ;loop 5 times
  ld hl, ScoreTxt
  ld b, $05
  res 3, (iy+5)         ;overwrite current screen with menu-texts
  jp _vputsn   	;print it to screen
ScoreTxt:
	.db 0,0,0,0,0

addbullet2:
	ld b, 5
addbullet:
	ld a, (hl)
	or a
	jr nz, doloopagian
	ld (hl), e
	inc hl
	ld (hl), d
	ret
doloopagian:
	inc hl
	inc hl
	djnz addbullet
	ret

addexplosion:
	ld hl, exdata
	ld b, 20
addexplosionloop:
	ld a, (hl)
	or a
	jr nz, doloopagianel
	ld (hl), e
	inc hl
	ld (hl), d
	inc hl
	ld (hl), a
	ret
doloopagianel:
	inc hl
	inc hl
	inc hl
	djnz addexplosionloop
	ret

opendoor:
	ld b, 31
odlp:
	push bc
	ld a, b
	ld (door), a
	call drawgamescreen
	call copyscreen				;time waster
	pop bc
	djnz odlp
	ld a, b
	ld (door), a
	ret

closedoor:
	ld b, 31
cdlp:
	push bc
	ld a, 32
	sub b
	ld (door), a
	call drawgamescreen
	call copyscreen				;time waster
	pop bc
	djnz cdlp
	ret

drawdoor:
	ld b, 0
	ld a, (door)
	or a
	ret z
	rla
	rla
	rla
	rla
	ld c, a
	ld a, b
	adc a, 0
	ld b, a
	ld hl, $9000
	ld (hl), 255
	ld de, $9001
	push bc
	ldir
	pop bc
	ld hl, $9000+703
	ld de, $9000+702
	ld (hl), 255
	lddr
	ret

drawstring
	push de
	ld (_penCol), de
	call _vputs
	pop de
	ret

drawmenuopt:
	ld a, (selector)
	cp c
	jr z, thisisselection
	inc c
	jp drawstring
thisisselection:
	set textInverse, (iy+textflags)
	call drawstring
	res textInverse, (iy+textflags)
	inc c
	ret

.end
